![Altars of Creation](https://i.imgur.com/FgOMpu9.png9)

# Altars of Creation
This mod adds a new location / dungeon (with two more planned) to the world with a risk / reward altar system. The location exterior contains an altar where the player must offer coins to enter the dungeon interior. The dungeons loot and creatures will change based on the amount of coins offered by the player. More coins gives more loot, but also harder creatures. This is the first release in my More World Locations series, see below for more details on the series.

## Features
- Adds one new location / dungeon to the world ("Kristnir's Cathedral")
- Adds new dungeon altar system to dynamically change dungeon loot & creatures based on players offering.
- Configurability: Location spawn quantities, amount of coins player must offer, creature spawns, loot lists.
- Dungeons can be repeated multiple times. Submit another offering in the altar to respawn loot and creatures. 
- (Coming soon) Two additional altar location / dungeons will be added using the same system.

## Location Details
Prefab Name: MWL_RuinsCathedral1
- Quantity: 10
- MinDistance: 1500
- MaxDistance: 3000
- MinDistanceFromSimilar: 1028 (the minimum distance from a location in the same group, "Ruins_large")
- Biome: Meadows
- Exterior creature spawners: 7
- Interior (dungeon) creature spawners: 20

## Altar & Offering System Details
In the basement of the location, there is an unique chest, which has the same model as personal chest. Open this chest and insert your offering into the slot then press the "Make Offering" button. Based on how much coins you offer, the dungeon loot and creatures will adjust. The three tiers available are...

Tier 1
- Player offers 200 coins
- Creatures = level 1 (no stars)
- One loot chest
- Loot list: Copper, Tin, Ruby

Tier 2
- Player offers 350 coins
- Creatures = level 2 (one star)
- Two loot chests
- Loot list: Copper, Bronze, SurtlingCore

Tier 3
- Player offers 500 coins
- Creatures = level 3 (two stars)
- Three loot chests
- Loot list: Bronze, IronScrap, SurtlingCore

## Instructions
- To add to a non-existing world, no action is required. Ensure the mod is installed and create a new world.
- To add to an existing world, use the [Upgrade World](https://valheim.thunderstore.io/package/JereKuusela/Upgrade_World/) with the command below: 

Command: `locations_add MWL_RuinsCathedral1 start`

## Custom Creature Spawns and Loot Lists
The creatures that spawn in the location exterior and dungeon interior are customizable. The loot that spawns in the location exterior and dungeon interior is also customizable. Modded creatures and items are supported. Create a new YAML (see below for file names) file in the BepinEx configuration folder (if using mod manager, then use the BepinEx config folder in profile folder). 

For creatures, each instance of the location will randomly select from the list of creatures in the the file. First, it will pick a random index (an item in the list), then it will increment through the list, assigning creatures to available creature spawners until each creature spawner has a creature. For the best results, scatter higher tier creatures throughout the list. You must use the creature's prefab name and not it's in-game name. See here for a list of vanilla creature prefab names: [Creatures List](https://valheim-modding.github.io/Jotunn/data/prefabs/character-list.html)

For loot, the exterior chests will randomly select items from the list. The interior chests will randomly select loot from the tier which the player has activated.

Creature file name: `warpalicious.MWL_Altars_of_Creation_Creatures.yml`
Creature file structure:
```
MWL_RuinsCathedral1:
  creatures:
    - Skeleton
    - Skeleton
    - Skeleton_Poison
    - Skeleton
    - Skeleton
    - Skeleton
    - Skeleton
    - Skeleton_Poison
    - Skeleton
```

Loot file name: `warpalicious.MWL_Altars_of_Creation_LootLists.yml`
Loot file structure:
```
MWL_RuinsCathedral1:
  interiorLootTier1:
    - Copper
    - Tin
    - Ruby
  interiorLootTier2:
    - Copper
    - Bronze
    - SurtlingCore
  interiorLootTier3:
    - Wood
    - Tin
    - SurtlingCore
  exteriorLoot:
    - Wood
    - Tin
    - CopperOre
    - Coins
```

## More World Locations
The goal of the More World Locations series is to solve Valheims exploration problem. Valheim has a giant map but relatively few points of interest (POI) to find. Once a player learns that each biome is just a copy of what they've already seen, exploring the rest of the map feels unnecessary. The More World Locations series will fix this problem by adding dozens of handcrafted, unique, and interesting POIs to the Valheim world.

## Compatibility
- Compatible with CreatureLevelandLootControl

## Credit & Thanks
This was by far the most chellenging mod and software project I've ever built. I could not have made it to the finish without the support of other mod developers and encouragement from community members. If you're someone that's interested in making mods, I encourage you to try it out!

## Donations/Tips
I make mods because I enjoy it and want to make Valheim more enjoyable for everyone. If you feel like saying thanks you can tip me here.

| My Ko-fi: | [![ko-fi](https://ko-fi.com/img/githubbutton_sm.svg)](https://ko-fi.com/warpalicious) |
|-----------|---------------|

## Source Code
Source code is available on Github.

| Github Repository: | <img height="18" src="https://github.githubassets.com/favicons/favicon-dark.svg"></img><a href="https://github.com/jneb802/altarsOfCreation"> Altars of Creation</a> |
|-----------|---------------|
